Index: admin/js/jsToolBar/popup_posts.js
===================================================================
--- admin/js/jsToolBar/popup_posts.js	(revision 2566)
+++ admin/js/jsToolBar/popup_posts.js	(revision 2566)
@@ -0,0 +1,16 @@
+$(function() {
+	$('#link-insert-cancel').click(function() {
+		window.close();
+	});
+
+	$('#form-entries tr>td.maximal>a').click(function() {
+		// Get post_id
+		var tb = window.opener.the_toolbar;
+		var data = tb.elements.link.data;
+
+		data.href = tb.stripBaseURL($(this).attr('title'));
+
+		tb.elements.link.fncall[tb.mode].call(tb);
+		window.close();
+	});
+});
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 2614)
+++ admin/media.php	(revision 2529)
@@ -75,5 +75,4 @@
 
 $page_url = 'media.php?popup='.$popup.'&post_id='.$post_id;
-$page_url = $core->callBehavior('adminMediaURL',$page_url);
 
 if ($popup) {
@@ -363,14 +362,4 @@
 }
 
-// Remove hidden directories (unless DC_SHOW_HIDDEN_DIRS is set to true)
-if (!defined('DC_SHOW_HIDDEN_DIRS') || (DC_SHOW_HIDDEN_DIRS == false)) {
-	for ($i = count($dir['dirs']) - 1; $i >= 0; $i--) {
-		if ($dir['dirs'][$i]->d) {
-			if (strpos($dir['dirs'][$i]->relname,'.') !== false) {
-				unset($dir['dirs'][$i]);
-			}
-		}
-	}
-}
 $items = array_values(array_merge($dir['dirs'],$dir['files']));
 
@@ -576,6 +565,6 @@
 		}
 	} else {
-		$link = 'media_item.php?id='.$f->media_id.'&amp;popup='.$popup.'&amp;post_id='.$post_id;
-		$link = $core->callBehavior('adminMediaURL',$link);
+		$link =
+		'media_item.php?id='.$f->media_id.'&amp;popup='.$popup.'&amp;post_id='.$post_id;
 	}
 
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 2614)
+++ admin/media_item.php	(revision 2566)
@@ -209,5 +209,5 @@
 if ($popup) {
 	$starting_scripts .=
-	$core->callBehavior('adminPopupMedia');
+	dcPage::jsLoad('js/jsToolBar/popup_media.js');
 }
 call_user_func($open_f,__('Media manager'),
Index: admin/popup_link.php
===================================================================
--- admin/popup_link.php	(revision 2614)
+++ admin/popup_link.php	(revision 2566)
@@ -19,5 +19,5 @@
 $title = !empty($_GET['title']) ? $_GET['title'] : '';
 
-dcPage::openPopup(__('Add a link'),$core->callBehavior('adminPopupLink'));
+dcPage::openPopup(__('Add a link'),dcPage::jsLoad('js/jsToolBar/popup_link.js'));
 
 echo '<h2 class="page-title">'.__('Add a link').'</h2>';
Index: admin/popup_posts.php
===================================================================
--- admin/popup_posts.php	(revision 2614)
+++ admin/popup_posts.php	(revision 2566)
@@ -48,5 +48,5 @@
 dcPage::openPopup(__('Add a link to an entry'),
 	dcPage::jsLoad('js/_posts_list.js').
-	$core->callBehavior('adminPopupPosts'));
+	dcPage::jsLoad('js/jsToolBar/popup_posts.js'));
 
 echo '<h2 class="page-title">'.__('Add a link to an entry').'</h2>';
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 2614)
+++ admin/post.php	(revision 2566)
@@ -375,8 +375,8 @@
 dcPage::open($page_title.' - '.__('Entries'),
 	dcPage::jsDatePicker().
+	dcPage::jsToolBar().
 	dcPage::jsModal().
 	dcPage::jsMetaEditor().
 	dcPage::jsLoad('js/_post.js').
-	$core->callBehavior('adminPostEditor').
 	dcPage::jsConfirmClose('entry-form','comment-form').
 	# --BEHAVIOR-- adminPostHeaders
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 2567)
+++ admin/preferences.php	(revision 2566)
@@ -305,5 +305,4 @@
 	($user_acc_nodragdrop ? '' : dcPage::jsLoad('js/_preferences-dragdrop.js')).
 	dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
-	dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 	dcPage::jsLoad('js/jquery/jquery.pwstrength.js').
 		'<script type="text/javascript">'."\n".
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 2614)
+++ inc/admin/lib.dc.page.php	(revision 2513)
@@ -589,5 +589,4 @@
 		'<script type="text/javascript">'."\n".
 		"//<![CDATA[\n".
-		'jsToolBar = {}, jsToolBar.prototype = { elements : {} };'."\n".
 		self::jsVar('dotclear.nonce',$GLOBALS['core']->getNonce()).
 		self::jsVar('dotclear.img_plus_src','images/expand.png').
@@ -829,8 +828,88 @@
 	}
 
-	
 	public static function jsToolBar()
 	{
-		# Deprecated but we keep this for plugins.
+		$res =
+		'<link rel="stylesheet" type="text/css" href="style/jsToolBar/jsToolBar.css" />'.
+		'<script type="text/javascript" src="js/jsToolBar/jsToolBar.js"></script>';
+
+		if (isset($GLOBALS['core']->auth) && $GLOBALS['core']->auth->getOption('enable_wysiwyg')) {
+			$res .= '<script type="text/javascript" src="js/jsToolBar/jsToolBar.wysiwyg.js"></script>';
+		}
+
+		$res .=
+		'<script type="text/javascript" src="js/jsToolBar/jsToolBar.dotclear.js"></script>'.
+		'<script type="text/javascript">'."\n".
+		"//<![CDATA[\n".
+		"jsToolBar.prototype.dialog_url = 'popup.php'; ".
+		"jsToolBar.prototype.iframe_css = '".
+		'body{'.
+		'font: 12px "DejaVu Sans","Lucida Grande","Lucida Sans Unicode",Arial,sans-serif;'.
+		'color : #000;'.
+		'background: #f9f9f9;'.
+		'margin: 0;'.
+		'padding : 2px;'.
+		'border: none;'.
+		(l10n::getTextDirection($GLOBALS['_lang']) == 'rtl' ? 'direction:rtl;' : '').
+		'}'.
+		'pre, code, kbd, samp {'.
+		'font-family:"Courier New",Courier,monospace;'.
+		'font-size : 1.1em;'.
+		'}'.
+		'code {'.
+		'color : #666;'.
+		'font-weight : bold;'.
+		'}'.
+		'body > p:first-child {'.
+		'margin-top: 0;'.
+		'}'.
+		"'; ".
+		"jsToolBar.prototype.base_url = '".html::escapeJS($GLOBALS['core']->blog->host)."'; ".
+		"jsToolBar.prototype.switcher_visual_title = '".html::escapeJS(__('visual'))."'; ".
+		"jsToolBar.prototype.switcher_source_title = '".html::escapeJS(__('source'))."'; ".
+		"jsToolBar.prototype.legend_msg = '".
+		html::escapeJS(__('You can use the following shortcuts to format your text.'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.none = '".html::escapeJS(__('-- none --'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.nonebis = '".html::escapeJS(__('-- block format --'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.p = '".html::escapeJS(__('Paragraph'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.h1 = '".html::escapeJS(__('Level 1 header'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.h2 = '".html::escapeJS(__('Level 2 header'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.h3 = '".html::escapeJS(__('Level 3 header'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.h4 = '".html::escapeJS(__('Level 4 header'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.h5 = '".html::escapeJS(__('Level 5 header'))."'; ".
+		"jsToolBar.prototype.elements.blocks.options.h6 = '".html::escapeJS(__('Level 6 header'))."'; ".
+		"jsToolBar.prototype.elements.strong.title = '".html::escapeJS(__('Strong emphasis'))."'; ".
+		"jsToolBar.prototype.elements.em.title = '".html::escapeJS(__('Emphasis'))."'; ".
+		"jsToolBar.prototype.elements.ins.title = '".html::escapeJS(__('Inserted'))."'; ".
+		"jsToolBar.prototype.elements.del.title = '".html::escapeJS(__('Deleted'))."'; ".
+		"jsToolBar.prototype.elements.quote.title = '".html::escapeJS(__('Inline quote'))."'; ".
+		"jsToolBar.prototype.elements.code.title = '".html::escapeJS(__('Code'))."'; ".
+		"jsToolBar.prototype.elements.br.title = '".html::escapeJS(__('Line break'))."'; ".
+		"jsToolBar.prototype.elements.blockquote.title = '".html::escapeJS(__('Blockquote'))."'; ".
+		"jsToolBar.prototype.elements.pre.title = '".html::escapeJS(__('Preformated text'))."'; ".
+		"jsToolBar.prototype.elements.ul.title = '".html::escapeJS(__('Unordered list'))."'; ".
+		"jsToolBar.prototype.elements.ol.title = '".html::escapeJS(__('Ordered list'))."'; ".
+
+		"jsToolBar.prototype.elements.link.title = '".html::escapeJS(__('Link'))."'; ".
+		"jsToolBar.prototype.elements.link.href_prompt = '".html::escapeJS(__('URL?'))."'; ".
+		"jsToolBar.prototype.elements.link.hreflang_prompt = '".html::escapeJS(__('Language?'))."'; ".
+
+		"jsToolBar.prototype.elements.img.title = '".html::escapeJS(__('External image'))."'; ".
+		"jsToolBar.prototype.elements.img.src_prompt = '".html::escapeJS(__('URL?'))."'; ".
+
+		"jsToolBar.prototype.elements.img_select.title = '".html::escapeJS(__('Media chooser'))."'; ".
+		"jsToolBar.prototype.elements.post_link.title = '".html::escapeJS(__('Link to an entry'))."'; ".
+
+		"jsToolBar.prototype.elements.removeFormat.title = '".html::escapeJS(__('Remove text formating'))."'; ";
+
+		if (!$GLOBALS['core']->auth->check('media,media_admin',$GLOBALS['core']->blog->id)) {
+			$res .= "jsToolBar.prototype.elements.img_select.disabled = true;\n";
+		}
+
+		$res .=
+		"\n//]]>\n".
+		"</script>\n";
+
+		return $res;
 	}
 
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 2567)
+++ inc/core/class.dc.blog.php	(revision 2626)
@@ -1894,5 +1894,5 @@
 	- post_id: (integer) Get comments belonging to given post_id
 	- cat_id: (integer or array) Get comments belonging to entries of given category ID
-	- comment_id: (integer or array) Get comment with given ID (or IDs)
+	- comment_id: (integer) Get comment with given ID
 	- comment_site: (string) Get comments with given comment_site
 	- comment_status: (integer) Get comments with given comment_status
@@ -1984,10 +1984,5 @@
 
 		if (isset($params['comment_id']) && $params['comment_id'] !== '') {
-			if (is_array($params['comment_id'])) {
-				array_walk($params['comment_id'],create_function('&$v,$k','if($v!==null){$v=(integer)$v;}'));
-			} else {
-				$params['comment_id'] = array((integer) $params['comment_id']);
-			}
-			$strReq .= 'AND comment_id '.$this->con->in($params['comment_id']);
+			$strReq .= 'AND comment_id = '.(integer) $params['comment_id'].' ';
 		}
 
@@ -2204,32 +2199,11 @@
 
 		$strReq =
-			'UPDATE '.$this->prefix.'comment tc ';
-
-		# mySQL uses "JOIN" synthax
-		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
-			$strReq .=
-				'JOIN '.$this->prefix.'post tp ON tc.post_id = tp.post_id ';
-		}
-
+			'UPDATE '.$this->prefix.'comment '.
+			'SET comment_status = '.$status.' ';
 		$strReq .=
-			'SET comment_status = '.$status.' ';
-
-		# pgSQL uses "FROM" synthax
-		if ($this->con->driver() != 'mysql' && $this->con->driver() != 'mysqli') {
-			$strReq .=
-				'FROM '.$this->prefix.'post tp ';
-		}
-
-		$strReq .=
-			"WHERE blog_id = '".$this->con->escape($this->id)."' ".
-			'AND comment_id'.$this->con->in($co_ids);
-
-		# add pgSQL "WHERE" clause
-		if ($this->con->driver() != 'mysql' && $this->con->driver() != 'mysqli') {
-			$strReq .=
-				'AND tc.post_id = tp.post_id ';
-		}
-
-		#If user is only usage, we need to check the post's owner
+			'WHERE comment_id'.$this->con->in($co_ids).
+			'AND post_id in (SELECT tp.post_id '.
+			'FROM '.$this->prefix.'post tp '.
+			"WHERE tp.blog_id = '".$this->con->escape($this->id)."' ";
 		if (!$this->core->auth->check('contentadmin',$this->id))
 		{
@@ -2237,5 +2211,5 @@
 				"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 		}
-
+		$strReq .= ')';
 		$this->con->execute($strReq);
 		$this->triggerComments($co_ids);
@@ -2284,30 +2258,17 @@
 		}
 
-		# mySQL uses "INNER JOIN" synthax
-		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
-			$strReq =
-				'DELETE FROM tc '.
-				'USING '.$this->prefix.'comment tc '.
-				'INNER JOIN '.$this->prefix.'post tp ';
-		}
-		# pgSQL uses nothing special
-		else {
-			$strReq =
-				'DELETE FROM '.$this->prefix.'comment tc '.
-				'USING '.$this->prefix.'post tp ';
-		}
-
-		$strReq .=
-			'WHERE tc.post_id = tp.post_id '.
-			"AND tp.blog_id = '".$this->con->escape($this->id)."' ".
-			'AND comment_id'.$this->con->in($co_ids);
-
+		$strReq =
+			'DELETE FROM '.$this->prefix.'comment '.
+			'WHERE comment_id'.$this->con->in($co_ids).' '.
+			'AND post_id in (SELECT tp.post_id '.
+			'FROM '.$this->prefix.'post tp '.
+			"WHERE tp.blog_id = '".$this->con->escape($this->id)."' ";
 		#If user can only delete, we need to check the post's owner
 		if (!$this->core->auth->check('contentadmin',$this->id))
 		{
 			$strReq .=
-				"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
-		}
-
+				"AND tp.user_id = '".$this->con->escape($this->core->auth->userID())."' ";
+		}
+		$strReq .= ")";
 		$this->con->execute($strReq);
 		$this->triggerComments($co_ids, true, $affected_posts);
@@ -2321,30 +2282,17 @@
 		}
 
-		# mySQL uses "INNER JOIN" synthax
-		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
-			$strReq =
-				'DELETE FROM tc '.
-				'USING '.$this->prefix.'comment tc '.
-				'INNER JOIN '.$this->prefix.'post tp ';
-		}
-		# pgSQL uses nothing special
-		else {
-			$strReq =
-				'DELETE FROM '.$this->prefix.'comment tc '.
-				'USING '.$this->prefix.'post tp ';
-		}
-
-		$strReq .=
-			'WHERE tc.post_id = tp.post_id '.
-			"AND tp.blog_id = '".$this->con->escape($this->id)."' ".
-			'AND comment_status = -2';
-
+		$strReq =
+			'DELETE FROM '.$this->prefix.'comment '.
+			'WHERE comment_status = -2 '.
+			'AND post_id in (SELECT tp.post_id '.
+			'FROM '.$this->prefix.'post tp '.
+			"WHERE tp.blog_id = '".$this->con->escape($this->id)."' ";
 		#If user can only delete, we need to check the post's owner
 		if (!$this->core->auth->check('contentadmin',$this->id))
 		{
 			$strReq .=
-				"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
-		}
-
+				"AND tp.user_id = '".$this->con->escape($this->core->auth->userID())."' ";
+		}
+		$strReq .= ")";
 		$this->con->execute($strReq);
 		$this->triggerBlog();
Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 2596)
+++ inc/core/class.dc.core.php	(revision 2566)
@@ -39,5 +39,4 @@
 	public $rest;		///< <b>dcRestServer</b>	dcRestServer object
 	public $log;		///< <b>dcLog</b>			dcLog object
-	public $stime;		///< <b>float</b>			starting time
 
 	private $versions = null;
@@ -60,10 +59,4 @@
 	public function __construct($driver, $host, $db, $user, $password, $prefix, $persist)
 	{
-		if (defined('DC_START_TIME')) {
-			$this->stime=DC_START_TIME;
-		} else {
-			$this->stime = microtime(true);
-		}
-
 		$this->con = dbLayer::init($driver,$host,$db,$user,$password,$persist);
 
@@ -989,17 +982,14 @@
 	private function getBlogCursor($cur)
 	{
-		if (($cur->blog_id !== null
-			&& !preg_match('/^[A-Za-z0-9._-]{2,}$/',$cur->blog_id)) ||
-			(!$cur->blog_id)) {
+		if ($cur->blog_id !== null
+		&& !preg_match('/^[A-Za-z0-9._-]{2,}$/',$cur->blog_id)) {
 			throw new Exception(__('Blog ID must contain at least 2 characters using letters, numbers or symbols.'));
 		}
 
-		if (($cur->blog_name !== null && $cur->blog_name == '') ||
-			(!$cur->blog_name)) {
+		if ($cur->blog_name !== null && $cur->blog_name == '') {
 			throw new Exception(__('No blog name'));
 		}
 
-		if (($cur->blog_url !== null && $cur->blog_url == '') ||
-			(!$cur->blog_url)) {
+		if ($cur->blog_url !== null && $cur->blog_url == '') {
 			throw new Exception(__('No blog URL'));
 		}
@@ -1316,8 +1306,6 @@
 				array('media_img_title_pattern','string','Title ;; Date(%b %Y) ;; separator(, )',
 				'Pattern to set image title when you insert it in a post'),
-				array('nb_post_for_home','integer',20,
-				'Number of entries on first home page'),
 				array('nb_post_per_page','integer',20,
-				'Number of entries on home pages and category pages'),
+				'Number of entries on home page and category pages'),
 				array('nb_post_per_feed','integer',20,
 				'Number of entries on feeds'),
@@ -1481,21 +1469,4 @@
 		}
 	}
-
-	/**
-	 Return elapsed time since script has been started
-	 @param   $mtime <b>float</b> timestamp (microtime format) to evaluate delta from
-	                       		  current time is taken if null
-	 @return <b>float</b>        elapsed time
-	 */
-	public function getElapsedTime ($mtime=null) {
-		if ($mtime !== null) {
-			return $mtime-$this->stime;
-		} else {
-			return microtime(true)-$this->stime;
-		}
-	}
 	//@}
-
-
-
 }
Index: inc/core/class.dc.namespace.php
===================================================================
--- inc/core/class.dc.namespace.php	(revision 2567)
+++ inc/core/class.dc.namespace.php	(revision 2566)
@@ -125,34 +125,4 @@
 
 	/**
-	Returns global setting value if exists.
-
-	@param	n		<b>string</b>		setting name
-	@return	<b>mixed</b>
-	*/
-	public function getGlobal($n)
-	{
-		if (isset($this->global_settings[$n]['value'])) {
-			return $this->global_settings[$n]['value'];
-		}
-
-		return null;
-	}
-
-	/**
-	Returns local setting value if exists.
-
-	@param	n		<b>string</b>		setting name
-	@return	<b>mixed</b>
-	*/
-	public function getLocal($n)
-	{
-		if (isset($this->local_settings[$n]['value'])) {
-			return $this->local_settings[$n]['value'];
-		}
-
-		return null;
-	}
-
-	/**
 	Magic __get method.
 	@copydoc ::get
Index: inc/core/class.dc.themes.php
===================================================================
--- inc/core/class.dc.themes.php	(revision 2607)
+++ inc/core/class.dc.themes.php	(revision 2566)
@@ -59,5 +59,5 @@
 		# Themes specifics properties
 		$properties = array_merge(
-			array('parent' => null, 'tplset' => DC_DEFAULT_TPLSET),
+			array('parent' => null),
 			$properties,
 			array('permissions' => 'admin') // force themes perms
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2615)
+++ inc/prepend.php	(revision 2591)
@@ -10,7 +10,4 @@
 #
 # -- END LICENSE BLOCK -----------------------------------------
-
-/* Start tick  */
-define('DC_START_TIME',microtime(true));
 
 /* ------------------------------------------------------------------------------------------- */
@@ -138,11 +135,10 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.7-dev');
+define('DC_VERSION','2.6.2');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
 define('DC_L10N_UPDATE_URL','http://services.dotclear.net/dc2.l10n/?version=%s');
-define('DC_DISTRIB_PLUGINS','aboutConfig,akismet,antispam,attachments,blogroll,blowupConfig,dclegacy,fairTrackbacks,importExport,maintenance,pages,pings,simpleMenu,tags,themeEditor,userPref,widgets,dcLegacyEditor');
+define('DC_DISTRIB_PLUGINS','aboutConfig,akismet,antispam,attachments,blogroll,blowupConfig,dclegacy,fairTrackbacks,importExport,maintenance,pages,pings,simpleMenu,tags,themeEditor,userPref,widgets');
 define('DC_DISTRIB_THEMES','blueSilence,blowupConfig,customCSS,default,ductile');
-define('DC_DEFAULT_TPLSET','mustek');
 
 if (!defined('DC_VENDOR_NAME')) {
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 2610)
+++ inc/public/class.dc.template.php	(revision 2590)
@@ -235,4 +235,102 @@
 	}
 
+	protected function compileFile($file)
+	{
+		$fc = file_get_contents($file);
+
+		$this->compile_stack[] = $file;
+
+		# Remove every PHP tags
+		if ($this->remove_php)
+		{
+			$fc = preg_replace('/<\?(?=php|=|\s).*?\?>/ms','',$fc);
+		}
+
+		# Transform what could be considered as PHP short tags
+		$fc = preg_replace('/(<\?(?!php|=|\s))(.*?)(\?>)/ms',
+		'<?php echo "$1"; ?>$2<?php echo "$3"; ?>',$fc);
+
+		# Remove template comments <!-- #... -->
+		$fc = preg_replace('/(^\s*)?<!-- #(.*?)-->/ms','',$fc);
+
+		# Lexer part : split file into small pieces
+		# each array entry will be either a tag or plain text
+		$blocks = preg_split(
+			'#(<tpl:\w+[^>]*>)|(</tpl:\w+>)|({{tpl:\w+[^}]*}})#msu',$fc,-1,
+			PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);
+
+		# Next : build semantic tree from tokens.
+		$rootNode = new tplNode();
+		$node = $rootNode;
+		$errors = array();
+		foreach ($blocks as $id => $block) {
+			$isblock = preg_match('#<tpl:(\w+)(?:(\s+.*?)>|>)|</tpl:(\w+)>|{{tpl:(\w+)(\s(.*?))?}}#ms',$block,$match);
+			if ($isblock == 1) {
+				if (substr($match[0],1,1) == '/') {
+					// Closing tag, check if it matches current opened node
+					$tag = $match[3];
+					if (($node instanceof tplNodeBlock) && $node->getTag() == $tag) {
+						$node->setClosing();
+						$node = $node->getParent();
+					} else {
+						// Closing tag does not match opening tag
+						// Search if it closes a parent tag
+						$search = $node;
+						while($search->getTag() != 'ROOT' && $search->getTag() != $tag) {
+							$search = $search->getParent();
+						}
+						if ($search->getTag() == $tag) {
+							$errors[] = sprintf(
+								__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
+								html::escapeHTML($node->getTag()));
+							$search->setClosing();
+							$node = $search->getParent();
+						} else {
+							$errors[]=sprintf(
+								__('Unexpected closing tag </tpl:%s> found.'),
+								$tag);;
+						}
+					}
+				} elseif (substr($match[0],0,1) == '{') {
+					// Value tag
+					$tag = $match[4];
+					$str_attr = '';
+					$attr = array();
+					if (isset($match[6])) {
+						$str_attr = $match[6];
+						$attr = $this->getAttrs($match[6]);
+					}
+					$node->addChild(new tplNodeValue($tag,$attr,$str_attr));
+				} else {
+					// Opening tag, create new node and dive into it
+					$tag = $match[1];
+					$newnode = new tplNodeBlock($tag,isset($match[2])?$this->getAttrs($match[2]):array());
+					$node->addChild($newnode);
+					$node = $newnode;
+				}
+			} else {
+				// Simple text
+				$node->addChild(new tplNodeText($block));
+			}
+		}
+
+		if (($node instanceof tplNodeBlock) && !$node->isClosed()) {
+			$errors[] = sprintf(
+				__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
+				html::escapeHTML($node->getTag()));
+		}
+
+		$err = "";
+		if (count($errors) > 0) {
+			$err = "\n\n<!-- \n".
+				__('WARNING: the following errors have been found while parsing template file :').
+				"\n * ".
+				join("\n * ",$errors).
+				"\n -->\n";
+		}
+
+		return $rootNode->compile($this).$err;
+	}
+
 	public function compileBlockNode($tag,$attr,$content)
 	{
@@ -245,5 +343,9 @@
 		$this->core->callBehavior('templateInsideBlock',$this->core,$this->current_tag,$attr,array(&$content));
 
-		$res .= parent::compileBlockNode($this->current_tag,$attr,$content);
+		if (isset($this->blocks[$this->current_tag])) {
+			$res .= call_user_func($this->blocks[$this->current_tag],$attr,$content);
+		} elseif ($this->unknown_block_handler != null) {
+			$res .= call_user_func($this->unknown_block_handler,$this->current_tag,$attr,$content);
+		}
 
 		# --BEHAVIOR-- templateAfterBlock
@@ -261,5 +363,9 @@
 		$res = $this->core->callBehavior('templateBeforeValue',$this->core,$this->current_tag,$attr);
 
-		$res .= parent::compileValueNode($this->current_tag,$attr,$str_attr);
+		if (isset($this->values[$this->current_tag])) {
+			$res .= call_user_func($this->values[$this->current_tag],$attr,ltrim($str_attr));
+		} elseif ($this->unknown_value_handler != null) {
+			$res .= call_user_func($this->unknown_value_handler,$this->current_tag,$attr,$str_attr);
+		}
 
 		# --BEHAVIOR-- templateAfterValue
@@ -267,4 +373,18 @@
 
 		return $res;
+	}
+
+	public function setUnknownValueHandler($callback)
+	{
+		if (is_callable($callback)) {
+			$this->unknown_value_handler = $callback;
+		}
+	}
+
+	public function setUnknownBlockHandler($callback)
+	{
+		if (is_callable($callback)) {
+			$this->unknown_block_handler = $callback;
+		}
 	}
 
@@ -1053,18 +1173,13 @@
 
 		if ($lastn != 0) {
-			// Set limit (aka nb of entries needed)
 			if ($lastn > 0) {
-				// nb of entries per page specified in template -> regular pagination
 				$p .= "\$params['limit'] = ".$lastn.";\n";
 			} else {
-				// nb of entries per page not specified -> use ctx settings
-				$p .= "\$params['limit'] = (\$_page_number == 1 ? \$_ctx->nb_entry_first_page : \$_ctx->nb_entry_per_page);\n";
+				$p .= "\$params['limit'] = \$_ctx->nb_entry_per_page;\n";
 			}
-			// Set offset (aka index of first entry)
+
 			if (!isset($attr['ignore_pagination']) || $attr['ignore_pagination'] == "0") {
-				// standard pagination, set offset
-				$p .= "\$params['limit'] = array((\$_page_number == 1 ? 0 : (\$_page_number - 2) * \$_ctx->nb_entry_per_page + \$_ctx->nb_entry_first_page),\$params['limit']);\n";
+				$p .= "\$params['limit'] = array(((\$_page_number-1)*\$params['limit']),\$params['limit']);\n";
 			} else {
-				// no pagination, get all posts from 0 to limit
 				$p .= "\$params['limit'] = array(0, \$params['limit']);\n";
 			}
Index: inc/public/default-templates/rss2.xsl
===================================================================
--- inc/public/default-templates/rss2.xsl	(revision 2566)
+++ inc/public/default-templates/rss2.xsl	(revision 2566)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+xmlns:content="http://purl.org/rss/1.0/modules/content/"
+xmlns="http://www.w3.org/1999/xhtml">
+
+<xsl:output method="html"/>
+
+<xsl:template match="/">
+<html>
+  <head>
+    <title>{{tpl:lang Subscribe to}} <xsl:value-of select="/rss/channel/title"/></title>
+    <style type="text/css">
+    <![CDATA[
+    body {
+      font: 80% Verdana,Arial,sans-serif;
+      margin: 20px 0;
+      padding: 0 0;
+      background: #fff;
+      color: #000;
+    }
+    a { color: #039; }
+    h1, h2 { font-family: Arial,sans-serif; }
+    h1 { font-size: 160%; margin: 0; }
+    h2 { font-size: 140%; font-weight: bold; margin: 0.5em 0 0.2em 0; }
+    h2 a { text-decoration: none; }
+    p { margin: 0 0 0.5em 0; }
+    #page {
+      margin: 0 80px;
+    }
+    #top {
+      background: #036;
+      padding : 1em;
+      color: #fff;
+    }
+    #top a {
+      color: #fff;
+      text-decoration: none;
+    }
+    #what {
+      padding: 1em;
+      background: #eee;
+      border-bottom: 1px solid #000;
+      font-size: 80%;
+    }
+    #what p {
+      margin: 0 0 0.5em 0;
+    }
+    #footer {
+      border-top: 1px solid #000;
+    }
+    #items {
+      background: #fff;
+      color: inherit;
+    }
+    #items div {
+      margin: 0 0 1em 0;
+    }
+    ]]>
+    </style>
+    <script type="text/javascript"><![CDATA[
+    window.onload = function() {
+      document.getElementById('feedurl').value = window.location.href;
+
+      // Ugly but works ;)
+      var c = document.getElementsByTagName('div');
+      var t = '';
+      for (var i=0; c.length-i != 0; i++) {
+        if (c[i].className == 'item-content') {
+          if (c[i].textContent) {
+            t = c[i].textContent;
+          } else if (c[i].innerText) {
+            t = c[i].innerText;
+          } else {
+            t = '';
+          }
+
+          if (t) { c[i].innerHTML = t; }
+        }
+      }
+    };
+    ]]></script>
+  </head>
+  <body>
+    <div id="page">
+      <div id="top">
+        <h1><a href="{/rss/channel/link}"><xsl:value-of select="/rss/channel/title"/></a></h1>
+        <p><xsl:value-of select="/rss/channel/description"/></p>
+      </div>
+      <div id="what">
+      <h3>{{tpl:lang What is an RSS feed?}}</h3>
+      <p>{{tpl:lang RSS feed is a free blog summary. It provides content
+      (either posts or comments) or  summaries of content, together with links
+      to the full versions, and other metadata. The last published items may
+      then be read by your favorite RSS
+      <a href="http://en.wikipedia.org/wiki/Aggregator">aggregator</a>.}}</p>
+      <h3>{{tpl:lang Subscribe}}</h3>
+      <p>{{tpl:lang Simply copy the following URL into your aggregator:}}</p>
+      <p><input type="text" size="60" value="" id="feedurl" /></p>
+      </div>
+      <div id="items">
+        <xsl:apply-templates select="//item"/>
+      </div>
+      <div id="footer">
+        <p><xsl:value-of select="/rss/channel/copyright"/></p>
+      </div>
+    </div>
+  </body>
+</html>
+</xsl:template>
+
+<!-- Item template -->
+<xsl:template match="item">
+  <div>
+    <h2><a href="{link}"><xsl:value-of select="title"/></a></h2>
+    <div class="item-content"><xsl:value-of select="description" /></div>
+  </div>
+</xsl:template>
+
+</xsl:stylesheet>
Index: inc/public/lib.tpl.context.php
===================================================================
--- inc/public/lib.tpl.context.php	(revision 2577)
+++ inc/public/lib.tpl.context.php	(revision 2566)
@@ -206,5 +206,7 @@
 
 		$nb_posts = $_ctx->pagination->f(0);
-		$nb_pages = ceil(($nb_posts - $_ctx->nb_entry_first_page) / $_ctx->nb_entry_per_page + 1);
+		$nb_per_page = $_ctx->post_params['limit'][1];
+
+		$nb_pages = ceil($nb_posts/$nb_per_page);
 
 		return $nb_pages;
Index: inc/public/lib.urlhandlers.php
===================================================================
--- inc/public/lib.urlhandlers.php	(revision 2585)
+++ inc/public/lib.urlhandlers.php	(revision 2566)
@@ -86,7 +86,4 @@
 			$_ctx->nb_entry_per_page = $core->blog->settings->system->nb_post_per_page;
 		}
-		if ($_ctx->nb_entry_first_page === null) {
-			$_ctx->nb_entry_first_page = $_ctx->nb_entry_per_page;
-		}
 
 		$tpl_file = $core->tpl->getFilePath($tpl);
@@ -191,5 +188,4 @@
 		else
 		{
-			$_ctx =& $GLOBALS['_ctx'];
 			$core =& $GLOBALS['core'];
 
@@ -200,7 +196,4 @@
 
 			if (empty($_GET['q'])) {
-				if ($core->blog->settings->system->nb_post_for_home !== null) {
-					$_ctx->nb_entry_first_page = $core->blog->settings->system->nb_post_for_home;
-				}
 				self::serveDocument('home.html');
 				$core->blog->publishScheduledEntries();
@@ -418,16 +411,10 @@
 					if ($content != '')
 					{
-						# --BEHAVIOR-- publicBeforeCommentTransform
-						$buffer = $core->callBehavior('publicBeforeCommentTransform',$content);
-						if ($buffer != '') {
-							$content = $buffer;
+						if ($core->blog->settings->system->wiki_comments) {
+							$core->initWikiComment();
 						} else {
-							if ($core->blog->settings->system->wiki_comments) {
-								$core->initWikiComment();
-							} else {
-								$core->initWikiSimpleComment();
-							}
-							$content = $core->wikiTransform($content);
+							$core->initWikiSimpleComment();
 						}
+						$content = $core->wikiTransform($content);
 						$content = $core->HTMLfilter($content);
 					}
Index: inc/public/prepend.php
===================================================================
--- inc/public/prepend.php	(revision 2567)
+++ inc/public/prepend.php	(revision 2566)
@@ -134,15 +134,10 @@
 	$__theme_tpl_path[] = $core->blog->themes_path.'/'.$__parent_theme.'/tpl';
 }
-$tplset = $core->themes->moduleInfo($core->blog->settings->system->theme,'tplset');
-if (!empty($tplset) && is_dir(dirname(__FILE__).'/default-templates/'.$tplset)) {
-	$core->tpl->setPath(
-		$__theme_tpl_path,
-		dirname(__FILE__).'/default-templates/'.$tplset,
-		$core->tpl->getPath());
-} else {
-	$core->tpl->setPath(
-		$__theme_tpl_path,
-		$core->tpl->getPath());
-}
+
+$core->tpl->setPath(
+	$__theme_tpl_path,
+	dirname(__FILE__).'/default-templates',
+	$core->tpl->getPath());
+
 $core->url->mode = $core->blog->settings->system->url_scan;
 
Index: plugins/antispam/filters/class.dc.filter.linkslookup.php
===================================================================
--- plugins/antispam/filters/class.dc.filter.linkslookup.php	(revision 2567)
+++ plugins/antispam/filters/class.dc.filter.linkslookup.php	(revision 2566)
@@ -48,8 +48,4 @@
 
 			$i = count($domain_elem) - 1;
-			if ($i == 0) {
-				// "domain" is 1 word long, don't check it
-				return null;
-			}
 			$host = $domain_elem[$i];
 			do
